#!/bin/sh
# PRIVATE_KEY_FILE is the one you have received from db2pro.com
# TARGET_HOST      is the user account (usually datacopyuser) and the sub-domain name which points to your server in the cloud
PRIVATE_KEY_FILE=[your-company]_datacopyuser.pem
TARGET_HOST=datacopyuser@[your-company].db2pro.com

SOURCE_DIR=./data
TARGET_DIR=/db2/data
FILE_LIST=files_to_send

interval=`expr 1 \* 300`

checkError() {
   if (( $? == 0 )); then
      return
   else
      echo "Program Terminated with error"
      exit 1
   fi
}

cd ${SOURCE_DIR}

while true
do
    echo "`date +%Y-%m-%d-%H-%M-%S` - top of the loop"
    start=`date +%s`
    end=`expr $start + $interval`

	ls *.tar.gz > ${FILE_LIST} 2>/dev/null
	sort ${FILE_LIST} > ${FILE_LIST}.sorted
	mv ${FILE_LIST}.sorted ${FILE_LIST}

	FileList=`cat ${FILE_LIST}`
	FileListLength=`cat ${FILE_LIST} | wc -l`
	echo "Number of files to send = "$FileListLength

	for sourceFile in $FileList; do
		echo "`date +%Y-%m-%d\ %H:%M:%S`: Moving ${sourceFile}"

		scp -i "../${PRIVATE_KEY_FILE}" -p ${sourceFile} ${TARGET_HOST}":"${TARGET_DIR}"/"${sourceFile}".inprogress"
		checkError

		ssh -i "../${PRIVATE_KEY_FILE}" ${TARGET_HOST} "chmod 666 ${TARGET_DIR}\"/\"${sourceFile}\".inprogress\" "
		checkError

		ssh -i "../${PRIVATE_KEY_FILE}" ${TARGET_HOST} "mv ${TARGET_DIR}\"/\"${sourceFile}\".inprogress\" ${TARGET_DIR}\"/\"${sourceFile}"
		checkError

		rm -f ${sourceFile}
		checkError

	done

    now=`date +%s`

    sleepTime=`expr $end - $now`
    if (( $sleepTime < 0 )); then
        sleepTime=0
    fi

    echo sleep $sleepTime seconds
    sleep $sleepTime 
done